;;  edivad-suite a simple suite of gimp scripts for simplify my life
;;  Copyright (C) 2008  Davide Giannella <edivad_@users.sourceforge.net>
;;
;;  This program is free software; you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation; version 2 of the License.
;; 
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License along
;;  with this program; if not, write to the Free Software Foundation, Inc.,
;;  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

;;;;
;; Take the active image and convert it for printing.
;; 
;; @param img SF-IMAGE the opened image
;; @param drw SF-DRAWABLE the active drawable
;; @param dpi SF-VALUE the desired DPI
(define (printify-image img drw dpi)
  (let*
      (
       (fname (parse-name (car (gimp-image-get-filename img))))
       (out-name (string-append fname "-print.tiff"))
       (new-img (car (gimp-image-duplicate img)))
       (drw2 0)
       )
    (gimp-image-undo-group-start new-img)
    (gimp-image-flatten new-img) ;;flatten the image
    (gimp-image-set-resolution new-img dpi dpi) ;;set desired resolution
    (set! drw2 (car (gimp-image-get-active-drawable new-img)))
    (file-tiff-save 1 new-img drw2 out-name out-name 0)
    (gimp-image-undo-group-end new-img)
    (gimp-image-delete new-img)
    )
  )

(script-fu-register "printify-image"
                    _"<Image>/Script-Fu/edivad-suite/Printify"
                    "Take the active image and convert it for printing"
                    "Davide Giannella"
                    "(C) Davide Giannella"
                    "November 2008"
                    ""
                    SF-IMAGE "Image" 0
                    SF-DRAWABLE "Drawable" 0
                    SF-VALUE "dpi" "300"
)